module ServiceLayerRest
    class TimeManagementController < ApplicationController
      include ServiceLayerHelper
      include Base
      include Dll

      def get_timesheet
        invalid_key = check_params([:from, :to], [:fct_code, :planarea_id, :employee_id])
        return render bad_params_for_render(invalid_key) unless invalid_key.blank?
  
        begin
          response_string, string_pointer = ServiceLayerDll.timesheet_get_Events(
            current_user.as_json,
            params[:fct_code].to_i,
            params[:planarea_id].to_i,
            params[:employee_id].to_i,
            params[:from],
            params[:to]
          )
          ServiceLayerDll.free_string(string_pointer)
  
          render parse_response_string_for_render(response_string)
        rescue Exception => e
          render parse_exception_for_render(e)
        end
      end
  
      def insert_timesheet
        invalid_key = check_params([:card_id, :booking, :bookingIntern, :bookingTime], [:fct_code, :employee_id])
        return render bad_params_for_render(invalid_key) unless invalid_key.blank?
  
        begin
          response_string, string_pointer = ServiceLayerDll.timesheet_add_Event(
            current_user.as_json,
            params[:fct_code].to_i,
            params[:employee_id].to_i,
            params[:card_id],
            params[:booking],
            params[:bookingIntern],
            params[:bookingTime],
            true
          )
          ServiceLayerDll.free_string(string_pointer)
  
          render parse_response_string_for_render(response_string)
        rescue Exception => e
          render parse_exception_for_render(e)
        end
      end
  
      def update_timesheet
        invalid_key = check_params([:bookingTime], [:fct_code, :bookingID])
        return render bad_params_for_render(invalid_key) unless invalid_key.blank?
  
        begin
          response_string, string_pointer = ServiceLayerDll.timesheet_change_Event(
            current_user.as_json,
            params[:fct_code].to_i,
            params[:bookingID].to_i,
            params[:bookingTime],
          )
          ServiceLayerDll.free_string(string_pointer)
  
          render parse_response_string_for_render(response_string)
        rescue Exception => e
          render parse_exception_for_render(e)
        end
      end
  
      def delete_timesheet
        invalid_key = check_params([], [:fct_code, :bookingID])
        return render bad_params_for_render(invalid_key) unless invalid_key.blank?
  
        begin
          response_string, string_pointer = ServiceLayerDll.timesheet_delete_Event(
            current_user.as_json,
            params[:fct_code].to_i,
            params[:bookingID].to_i
          )
          ServiceLayerDll.free_string(string_pointer)
  
          render parse_response_string_for_render(response_string)
        rescue Exception => e
          render parse_exception_for_render(e)
        end
      end
    end
end